"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var enzyme_1 = require("enzyme");
var react_1 = __importDefault(require("react"));
var ts_mockito_1 = require("ts-mockito");
var testUtils_1 = require("../../testUtils");
var dataHOC_1 = require("./dataHOC");
describe("Auto URL data sync", function () {
    var TestComponent = testUtils_1.createTestComponent();
    var EnhancedComponent = dataHOC_1.urlDataSync()(TestComponent);
    var urlDataSync;
    var WrappedElement;
    beforeEach(function () {
        urlDataSync = ts_mockito_1.spy({
            get: function () { return Promise.reject(""); },
            update: function () { return Promise.reject(""); },
            updateURLQuery: function () { return Promise.reject(""); },
            getURLQuery: function () { return Promise.reject(""); }
        });
        WrappedElement = react_1.default.createElement(EnhancedComponent, { urlDataSync: ts_mockito_1.instance(urlDataSync) });
    });
    it("Should perform get correctly", function () { return __awaiter(_this, void 0, void 0, function () {
        var data, query, wrapper, getData, _a, result, isLoadingData, urlQuery;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    data = { a: 0, b: 1, c: 2 };
                    query = { a: "1", b: "2" };
                    ts_mockito_1.when(urlDataSync.get(ts_mockito_1.anything())).thenResolve(data);
                    ts_mockito_1.when(urlDataSync.getURLQuery()).thenResolve(query);
                    wrapper = enzyme_1.mount(WrappedElement);
                    getData = wrapper.find(TestComponent).props().getData;
                    getData();
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 1:
                    _b.sent();
                    wrapper.setProps({});
                    _a = wrapper
                        .find(TestComponent)
                        .props(), result = _a.data, isLoadingData = _a.isLoadingData, urlQuery = _a.urlQuery;
                    // Then
                    ts_mockito_1.verify(urlDataSync.get(undefined)).once();
                    ts_mockito_1.verify(urlDataSync.getURLQuery()).once();
                    expect(isLoadingData).toBeFalsy();
                    expect(result).toEqual(data);
                    expect(urlQuery).toEqual(query);
                    return [2 /*return*/];
            }
        });
    }); });
    it("Should perform save correctly", function () { return __awaiter(_this, void 0, void 0, function () {
        var newData, wrapper, updateData, saveData, loading1, _a, result, loading2;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    newData = { a: 1, b: 2, c: 3 };
                    ts_mockito_1.when(urlDataSync.update(ts_mockito_1.anything())).thenResolve(newData);
                    ts_mockito_1.when(urlDataSync.getURLQuery()).thenResolve({});
                    wrapper = enzyme_1.mount(WrappedElement);
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 1:
                    _b.sent();
                    wrapper.setProps({});
                    updateData = wrapper.find(TestComponent).props().updateData;
                    updateData(newData);
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 2:
                    _b.sent();
                    wrapper.setProps({});
                    saveData = wrapper.find(TestComponent).props().saveData;
                    saveData();
                    wrapper.setProps({});
                    loading1 = wrapper.find(TestComponent).props().isLoadingData;
                    expect(loading1).toBeTruthy();
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 3:
                    _b.sent();
                    wrapper.setProps({});
                    _a = wrapper
                        .find(TestComponent)
                        .props(), result = _a.data, loading2 = _a.isLoadingData;
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 4:
                    _b.sent();
                    // Then
                    ts_mockito_1.verify(urlDataSync.update(ts_mockito_1.deepEqual(newData))).once();
                    expect(loading2).toBeFalsy();
                    expect(result).toEqual(newData);
                    return [2 /*return*/];
            }
        });
    }); });
    it("Should update URL queries correctly", function () { return __awaiter(_this, void 0, void 0, function () {
        var query, wrapper, updateURLQuery, urlQuery;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    // Setup
                    ts_mockito_1.when(urlDataSync.get(ts_mockito_1.anything())).thenResolve({});
                    ts_mockito_1.when(urlDataSync.getURLQuery()).thenResolve({});
                    ts_mockito_1.when(urlDataSync.updateURLQuery(ts_mockito_1.anything())).thenResolve("changed");
                    query = { a: "1", b: "2" };
                    wrapper = enzyme_1.mount(WrappedElement);
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 1:
                    _a.sent();
                    wrapper.setProps({});
                    updateURLQuery = wrapper.find(TestComponent).props().updateURLQuery;
                    updateURLQuery(query);
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 2:
                    _a.sent();
                    wrapper.setProps({});
                    urlQuery = wrapper.find(TestComponent).props().urlQuery;
                    // Then
                    ts_mockito_1.verify(urlDataSync.get(undefined)).once();
                    ts_mockito_1.verify(urlDataSync.getURLQuery()).once();
                    ts_mockito_1.verify(urlDataSync.updateURLQuery(ts_mockito_1.deepEqual(query)));
                    expect(urlQuery).toEqual(query);
                    return [2 /*return*/];
            }
        });
    }); });
    it("Should append URL queries correctly", function () { return __awaiter(_this, void 0, void 0, function () {
        var oldQuery, newQuery, wrapper, appendURLQuery, urlQuery;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    oldQuery = { a: "1", b: "2", c: "3" };
                    newQuery = { a: "2", b: "3" };
                    ts_mockito_1.when(urlDataSync.get(ts_mockito_1.anything())).thenResolve({});
                    ts_mockito_1.when(urlDataSync.getURLQuery()).thenResolve(oldQuery);
                    ts_mockito_1.when(urlDataSync.updateURLQuery(ts_mockito_1.anything())).thenResolve("changed");
                    wrapper = enzyme_1.mount(WrappedElement);
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 1:
                    _a.sent();
                    wrapper.setProps({});
                    appendURLQuery = wrapper.find(TestComponent).props().appendURLQuery;
                    appendURLQuery(newQuery);
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 2:
                    _a.sent();
                    wrapper.setProps({});
                    urlQuery = wrapper.find(TestComponent).props().urlQuery;
                    // Then
                    expect(urlQuery).toEqual(__assign({}, oldQuery, newQuery));
                    return [2 /*return*/];
            }
        });
    }); });
    it("Should not get data if urlQuery does not change", function () { return __awaiter(_this, void 0, void 0, function () {
        var wrapper, updateURLQuery;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    // Setup
                    ts_mockito_1.when(urlDataSync.get(ts_mockito_1.anything())).thenResolve({});
                    ts_mockito_1.when(urlDataSync.getURLQuery()).thenResolve({});
                    ts_mockito_1.when(urlDataSync.updateURLQuery(ts_mockito_1.anything())).thenResolve("unchanged");
                    wrapper = enzyme_1.mount(WrappedElement);
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 1:
                    _a.sent();
                    wrapper.setProps({});
                    updateURLQuery = wrapper.find(TestComponent).props().updateURLQuery;
                    updateURLQuery({});
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 2:
                    _a.sent();
                    // Then
                    ts_mockito_1.verify(urlDataSync.get(undefined)).never();
                    ts_mockito_1.verify(urlDataSync.get(ts_mockito_1.anything())).never();
                    ts_mockito_1.verify(urlDataSync.getURLQuery()).once();
                    ts_mockito_1.verify(urlDataSync.updateURLQuery(ts_mockito_1.deepEqual({})));
                    return [2 /*return*/];
            }
        });
    }); });
    it("Should set error when getting data fails", function () { return __awaiter(_this, void 0, void 0, function () {
        var error, wrapper, getData, dataError;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    error = new Error("error!");
                    ts_mockito_1.when(urlDataSync.get(ts_mockito_1.anything())).thenReject(error);
                    ts_mockito_1.when(urlDataSync.getURLQuery()).thenResolve({});
                    wrapper = enzyme_1.mount(WrappedElement);
                    getData = wrapper.find(TestComponent).props().getData;
                    return [4 /*yield*/, getData()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 2:
                    _a.sent();
                    wrapper.setProps({});
                    dataError = wrapper.find(TestComponent).props().dataError;
                    // Then
                    expect(dataError).toEqual(error);
                    return [2 /*return*/];
            }
        });
    }); });
    it("Should set error when saving fails", function () { return __awaiter(_this, void 0, void 0, function () {
        var error, wrapper, saveData, dataError;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    error = new Error("error!");
                    ts_mockito_1.when(urlDataSync.get(ts_mockito_1.anything())).thenResolve({});
                    ts_mockito_1.when(urlDataSync.getURLQuery()).thenResolve({});
                    ts_mockito_1.when(urlDataSync.update(ts_mockito_1.anything())).thenReject(error);
                    wrapper = enzyme_1.mount(WrappedElement);
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 1:
                    _a.sent();
                    wrapper.setProps({});
                    saveData = wrapper.find(TestComponent).props().saveData;
                    saveData();
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 2:
                    _a.sent();
                    wrapper.setProps({});
                    dataError = wrapper.find(TestComponent).props().dataError;
                    // Then
                    expect(dataError).toEqual(error);
                    return [2 /*return*/];
            }
        });
    }); });
});
describe("Cursor pagination", function () {
    var TestComponent = testUtils_1.createTestComponent(dataHOC_1.cursorPagination);
    var EnhancedComponent = dataHOC_1.cursorPagination()(TestComponent);
    var WrappedElement;
    beforeEach(function () {
        WrappedElement = react_1.default.createElement(EnhancedComponent, null);
    });
    it("Should set next/previous correctly", function () { return __awaiter(_this, void 0, void 0, function () {
        var wrapper, _a, setNext, setHasNext, _b, next, hasNext, _c, setPrevious, setHasPrevious, _d, previous, hasPrevious;
        return __generator(this, function (_e) {
            wrapper = enzyme_1.mount(WrappedElement);
            _a = wrapper.find(TestComponent).props(), setNext = _a.setNext, setHasNext = _a.setHasNext;
            setNext("next");
            setHasNext(true);
            wrapper.setProps({});
            _b = wrapper.find(TestComponent).props(), next = _b.next, hasNext = _b.hasNext;
            expect(next).toEqual("next");
            expect(hasNext).toEqual(hasNext);
            _c = wrapper.find(TestComponent).props(), setPrevious = _c.setPrevious, setHasPrevious = _c.setHasPrevious;
            setPrevious("previous");
            setHasPrevious(true);
            wrapper.setProps({});
            _d = wrapper.find(TestComponent).props(), previous = _d.previous, hasPrevious = _d.hasPrevious;
            expect(previous).toEqual("previous");
            expect(hasPrevious).toEqual(true);
            return [2 /*return*/];
        });
    }); });
});
describe("URL paginated data sync", function () {
    var TestComponent = testUtils_1.createTestComponent(dataHOC_1.urlCursorPaginatedDataSync);
    var EnhancedComponent = dataHOC_1.urlCursorPaginatedDataSync()(TestComponent);
    var urlDataSync;
    var WrappedElement;
    beforeEach(function () {
        urlDataSync = ts_mockito_1.spy({
            get: function () { return Promise.reject(""); },
            update: function () { return Promise.reject(""); },
            updateURLQuery: function () { return Promise.reject(""); },
            getURLQuery: function () { return Promise.reject(""); }
        });
        WrappedElement = react_1.default.createElement(EnhancedComponent, { urlDataSync: ts_mockito_1.instance(urlDataSync) });
    });
    it("Should go to next page correctly", function () { return __awaiter(_this, void 0, void 0, function () {
        var urlQuery, wrapper, getData, goToNextPage;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    urlQuery = { a: "1", b: "2", c: "3" };
                    ts_mockito_1.when(urlDataSync.get(ts_mockito_1.anything())).thenResolve({
                        results: [],
                        next: "next",
                        previous: "previous"
                    });
                    ts_mockito_1.when(urlDataSync.getURLQuery()).thenResolve(urlQuery);
                    ts_mockito_1.when(urlDataSync.updateURLQuery(ts_mockito_1.anything())).thenResolve("changed");
                    wrapper = enzyme_1.mount(WrappedElement);
                    getData = wrapper.find(TestComponent).props().getData;
                    getData();
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 1:
                    _a.sent();
                    wrapper.setProps({});
                    goToNextPage = wrapper.find(TestComponent).props().goToNextPage;
                    goToNextPage();
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 2:
                    _a.sent();
                    // Then
                    ts_mockito_1.verify(urlDataSync.updateURLQuery(ts_mockito_1.deepEqual(__assign({}, urlQuery, { next: "next", previous: undefined })))).once();
                    return [2 /*return*/];
            }
        });
    }); });
    it("Should go to previous page correctly", function () { return __awaiter(_this, void 0, void 0, function () {
        var urlQuery, wrapper, getData, goToPreviousPage;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    urlQuery = { a: "1", b: "2", c: "3" };
                    ts_mockito_1.when(urlDataSync.get(ts_mockito_1.anything())).thenResolve({
                        results: [],
                        next: "next",
                        previous: "previous"
                    });
                    ts_mockito_1.when(urlDataSync.getURLQuery()).thenResolve(urlQuery);
                    ts_mockito_1.when(urlDataSync.updateURLQuery(ts_mockito_1.anything())).thenResolve("changed");
                    wrapper = enzyme_1.mount(WrappedElement);
                    getData = wrapper.find(TestComponent).props().getData;
                    getData();
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 1:
                    _a.sent();
                    wrapper.setProps({});
                    goToPreviousPage = wrapper.find(TestComponent).props().goToPreviousPage;
                    goToPreviousPage();
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 2:
                    _a.sent();
                    // Then
                    ts_mockito_1.verify(urlDataSync.updateURLQuery(ts_mockito_1.deepEqual(__assign({}, urlQuery, { next: undefined, previous: "previous" })))).once();
                    return [2 /*return*/];
            }
        });
    }); });
    it("Should map data to array", function () { return __awaiter(_this, void 0, void 0, function () {
        var results, limit, order, sortField, wrapper, getData, _a, data, resultLimit, resultOrder, resultSortField;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    results = [1, 2, 3];
                    limit = 1000;
                    order = "ascend";
                    sortField = "abc";
                    ts_mockito_1.when(urlDataSync.get(ts_mockito_1.anything())).thenResolve({
                        limit: limit,
                        order: order,
                        results: results,
                        sortField: sortField
                    });
                    ts_mockito_1.when(urlDataSync.getURLQuery()).thenResolve({});
                    wrapper = enzyme_1.mount(WrappedElement);
                    getData = wrapper.find(TestComponent).props().getData;
                    getData();
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 1:
                    _b.sent();
                    wrapper.setProps({});
                    _a = wrapper.find(TestComponent).props(), data = _a.data, resultLimit = _a.limit, resultOrder = _a.order, resultSortField = _a.sortField;
                    // Then
                    expect(data).toEqual(results);
                    expect(resultLimit).toEqual(limit);
                    expect(resultOrder).toEqual(order);
                    expect(resultSortField).toEqual(sortField);
                    return [2 /*return*/];
            }
        });
    }); });
    it("Should give default result array if data is falsy", function () { return __awaiter(_this, void 0, void 0, function () {
        var wrapper, getData, _a, data, limit, order, sortField;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    // Setup
                    ts_mockito_1.when(urlDataSync.get(ts_mockito_1.anything())).thenResolve(null);
                    ts_mockito_1.when(urlDataSync.getURLQuery()).thenResolve({});
                    wrapper = enzyme_1.mount(WrappedElement);
                    getData = wrapper.find(TestComponent).props().getData;
                    getData();
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 1:
                    _b.sent();
                    wrapper.setProps({});
                    _a = wrapper
                        .find(TestComponent)
                        .props(), data = _a.data, limit = _a.limit, order = _a.order, sortField = _a.sortField;
                    // Then
                    expect(data).toEqual([]);
                    expect(limit).toEqual(undefined);
                    expect(order).toEqual(undefined);
                    expect(sortField).toEqual(undefined);
                    return [2 /*return*/];
            }
        });
    }); });
    it("Should give default result array if results are falsy", function () { return __awaiter(_this, void 0, void 0, function () {
        var wrapper, getData, data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    // Setup
                    ts_mockito_1.when(urlDataSync.get(ts_mockito_1.anything())).thenResolve({ results: null });
                    ts_mockito_1.when(urlDataSync.getURLQuery()).thenResolve({});
                    wrapper = enzyme_1.mount(WrappedElement);
                    getData = wrapper.find(TestComponent).props().getData;
                    getData();
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 1:
                    _a.sent();
                    wrapper.setProps({});
                    data = wrapper.find(TestComponent).props().data;
                    // Then
                    expect(data).toEqual([]);
                    return [2 /*return*/];
            }
        });
    }); });
});
