import axios from "axios";
export declare function createBaseClient(client?: Pick<typeof axios, "get" | "post" | "patch" | "delete" | "head">): HTTPClient;
/**
 * Treat client and server as if originating from the same domain, and whatever
 * URL the client is at, the server has the corresponding URL that contains the
 * data. This is assuming there is a subdomain called "api" for the server at
 * the same domain.
 *
 * e.g.
 * client -> https://localhost:8000/users/
 * server -> https://api.localhost:8000/users/1
 */
export declare function createRelativeClient({ location }: Pick<Window, "location">, client: HTTPClient): RelativeHTTPClient;
//# sourceMappingURL=client.d.ts.map